#include <atar/list.h>

#include <atar.h>

#include <stdio.h>
#include <stdlib.h>

extern char atar_verbose;

int oct2bin(char* buf, int size){
	if(buf[0] == 0) return 0;
	int result = 0;
	int i;
	for(i = 0; i < size; i++){
		result *= 8;
		result += buf[i] - '0';
	}
	return result;
}

void process_file(struct atar_ustar_header* ustar, FILE* f){
	int length = oct2bin(ustar->uh_size, 11) == 0 ? 0 : ((oct2bin(ustar->uh_size, 11) / 512) + 1) * 512;
	if(atar_verbose){
		printf("%c", atar_ustar_type(ustar->uh_type));
		printf("%8s %8s", ustar->uh_uname, ustar->uh_gname);
		printf("%11d ", oct2bin(ustar->uh_size, 11));
	}
	printf("%s\n", ustar->uh_name);
	char* buf = malloc(length);
	fread(buf, length, 1, f);
	free(buf);
}

void atar_list(char* tar){
	struct atar_ustar_header* ustar = malloc(sizeof(*ustar));
	FILE* f = fopen(tar, "r");
	char* buffer = malloc(sizeof(*ustar));
	fread(buffer, sizeof(*ustar), 1, f);

	char* buf = malloc(12);
	fread(buf, 12, 1, f);
	free(buf);
	atar_ustar_read_header(ustar, buffer);
	process_file(ustar, f);

	while(1){
		fread(buffer, sizeof(*ustar), 1, f);
		if(memcmp(buffer + 257, "ustar", 5) != 0) break;
		buf = malloc(12);
		fread(buf, 12, 1, f);
		free(buf);
		atar_ustar_read_header(ustar, buffer);
		process_file(ustar, f);
	}
	free(buffer);
	fclose(f);
}
