#include <stdio.h>
#include <unistd.h>

char* tar_file;
char** argv;
int argc;
char atar_verbose;

void atar_help(FILE* std){
	fprintf(std, "Usage: %s [options]\n", argv[0]);
}

int main(int argc_, char** argv_){
	tar_file = NULL;
	argv = argv_;
	argc = argc_;
	atar_verbose = 0;
	if(argv[1] == NULL){
		atar_help(stderr);
		return 1;
	}else{
		char opt;
		int i;
		enum {
			M_NONE,
			M_LIST
		} MODES;
		char mode = M_NONE;
		for(i = 0; argv[1][i] != 0; i++){
			opt = argv[1][i];
			if(opt == 't'){
				mode = M_LIST;
			}else if(opt == 'v'){
				atar_verbose = 1;
			}else if(opt == 'f'){
				char* file = argv[2];
				char fail = 0;
				if(file == NULL){
					fail = 1;
				}else if(access(file, R_OK)){
					fprintf(stderr, "%s: %s cannot be read\n", argv[0], file);
					fail = 1;
				}
				if(fail){
					fprintf(stderr, "%s: f option needs filename\n", argv[0]);
					return 1;
				}
				tar_file = file;
			}
		}
		if(tar_file == NULL){
			fprintf(stderr, "%s: file must be specified\n", argv[0]);
			atar_help(stderr);
			return 1;
		}
		if(mode == M_NONE){
			fprintf(stderr, "%s: c, t, or x must be specified\n", argv[0]);
			atar_help(stderr);
			return 1;
		}else{
			switch(mode){
				case M_LIST:
					atar_list(tar_file);
					break;
			}
		}
	}
	return 0;
}
